﻿module.component('fsrAppNav', {
    controllerAs: 'appNav',
    templateUrl: './templates/components/app-nav.component.html',
    controller: ['$rootScope', '$window', '$log', '$location', 'AuthService', 'AppStateService', 'dataService', 'sportContextService', 'navService', function ($rootScope, $window, $log, $location, AuthService, AppStateService, dataService, sportContextService, navService) {
        
        var vm = this;

        vm.error = { message: '' };
        vm.sportSelectorOpen = false;

        vm.navService = navService;

        vm.goBack = function () {
            $rootScope.back();
            navService.pop();
        };

        vm.loggedInUser = function () {
            return AuthService.getUserData();
        };

        function getSportsOptions() {
            dataService.Sport.get(function success(sports) {
                vm.sportsOptions = sports;
            }, function error(err) {
                $log.debug('Error:' + JSON.stringify(err));
                vm.error.message = err.data ? err.data.Message : 'Error Retrieving Sports';
            });
        }

        vm.context = { selected: vm.loggedInUser().username ? sportContextService.getContext(): undefined };

        vm.changeContext = function (sport) {
            if (sport) {
                vm.context.selected = sport;
            }
            sportContextService.setContext(vm.context.selected);
            vm.sportSelectorOpen = false;

            // Reload the tab since the sport context has changed
            if ($location.path() == "/admin") {
                $window.location.reload();
            }
            else {
                $rootScope.$broadcast("sport:contextchanged", { tabIndex: AppStateService.getTab() });
            }
        };

        function init() {
            getSportsOptions();
        };

        init();

    }]
});