﻿module.component('fsrTrendingPicks', {
    controllerAs: 'trendingPicks',
    bindings: {
        parent: "="
    },
    templateUrl: './templates/components/trending-picks.component.html',
    controller: ['$rootScope', '$log', 'dataService', function ($rootScope, $log, dataService) {
        
        var vm = this;
        vm.error = { message: '' };
        vm.loading = { value: 0 };
        var page = $rootScope.getNavigator().getCurrentPage();
        vm.raceId = page.options.race.race.id;

        function init() {
            getTrendingAthletes();
        };

        function getTrendingAthletes() {
            vm.loading.value++;

            dataService.Race.queryTrendingAthletes({ id: vm.raceId },
                function success(data) {
                    vm.loading.value--;
                    vm.parent.$parent.trending = data;
                },
                function error(err) {
                    vm.loading.value--;
                    $log.debug('Error:' + JSON.stringify(e));
                    vm.message = e.data ? e.data.Message : 'Error Retrieving Trending Picks';
                });
        }

        init();

    }]
});