﻿module.component('fsrWebsiteNav', {
    controllerAs: 'websiteNav',
    templateUrl: './templates/components/website-nav.component.html',
    controller: ['$rootScope', '$location', '$window', '$log', 'AuthService', 'AppStateService', 'dataService', 'sportContextService', function ($rootScope, $location, $window, $log, AuthService, AppStateService, dataService, sportContextService) {

        var vm = this;

        vm.error = { message: '' };

        vm.loggedInUser = function () {
            return AuthService.getUserData();
        };

        dataService.Sport.get(function success(sports) {
            vm.sportsOptions = sports;
        }, function error(err) {
            $log.debug('Err:' + JSON.stringify(err));
            vm.error.message = err.data ? err.data.Message : 'Error Retrieving Sports';
        });

        vm.context = { selected: vm.loggedInUser().username ? sportContextService.getContext() : undefined };

        vm.changeContext = function() {
            sportContextService.setContext(vm.context.selected);
            // Reload the page since the sport context has changed
            if ($location.path() == "/admin") {
                $window.location.reload();
            }
            else {
                $rootScope.$broadcast("sport:contextchanged", { tabIndex: AppStateService.getTab() });
            }
        };

        vm.showLogin = function () {
            vm.menuOpen = false;
            if ($rootScope.getNavigator().getCurrentPage().page !== 'partials/login/login.html') {
                $rootScope.getNavigator().pushPage('partials/login/login.html');
            }
        };

        vm.showRegister = function () {
            vm.menuOpen = false;
            if ($rootScope.getNavigator().getCurrentPage().page !== 'partials/login/register.html') {
                $rootScope.getNavigator().pushPage('partials/login/register.html');
            }
        };

        vm.menuOpen = false;

        vm.toggleMenu = function () {
            vm.menuOpen = !vm.menuOpen;
        };

        vm.isBlog = function () {
            return $location.url() === "/blog";
        };

        vm.logout = function () {
            vm.menuOpen = false;
            AuthService.logout();
        };
    }]
});