module.controller('AdsCtrl', ['$scope','$rootScope', '$sce', 'iconService','$interval',
    function ($scope, $rootScope, $sce, iconService, $interval) {
        var defaultAd = {};
        var lastServiceCheck = 0;

        //---Public Properties
        $scope.ads = [];
        $scope.currentAd = defaultAd;
        iconService.currentAd = defaultAd;
        $rootScope.$broadcast('icon-changed');

    	//--Initial Data Load
        loadAds(showNextAd);

    	//---IO functions----
    	function loadAds(next) {
    	    iconService.Icons.query({}, function success(data) {
    			//load existing
    	        $scope.ads = data.map(function (ad) {
    	            if (!ad.trustedHtml) {
    	                ad.trustedHtml = $sce.trustAsHtml(ad.html);
    	            }
    	            if (!ad.trustedSidebarHtml && !ad.sidebar_image_path) {
    	                ad.trustedSidebarHtml = $sce.trustAsHtml(ad.sidebar_url);
    	            }
    	            return ad;
    	        });
    			lastServiceCheck = (new Date()).valueOf();
                if(next) next();
    		}, function (err) {
    		    lastServiceCheck = (new Date()).valueOf();
                if(next) next();
    		});
    	}

        //--Cycle to next ad every 15 seconds
        $interval(showNextAd, 15000);

        //---Cycle Ads functions----

        function getRandomAd() {
            var randomAd = defaultAd;
            if ($scope.ads && $scope.ads.length > 0) {
                randomAd = $scope.ads[getRandomInt(0, $scope.ads.length - 1)];
            }
            return randomAd;
        }

        function getRandomInt(min, max) {
            return Math.floor(Math.random() * (max - min + 1)) + min;
        }

        function showNextAd() {
            var oneDay = 86400000;
            // if it has been more than a day, reload the adds
            if ((new Date()).valueOf() > (new Date(lastServiceCheck).valueOf() + oneDay)) {
                lastServiceCheck = (new Date()).valueOf() - (oneDay / 2);
                loadAds(showNextAd());
            }
            else{
                var nextAd = defaultAd;
                if ($scope.ads && $scope.ads.length > 0) {
                	var current = $scope.ads.indexOf($scope.currentAd);
                    var next = current + 1 >= $scope.ads.length ? 0 : current + 1;
                    nextAd = $scope.ads[next];
                    if (!nextAd.loading_image_path) { nextAd.loading_image_path = nextAd.image_path; }
                    //set in service
                    iconService.currentAd = nextAd;
                    //Raise the event that the ad changed
                    $rootScope.$broadcast('icon-changed');
                }
                $scope.currentAd = nextAd;
            }

        };




    }]);
