﻿module.controller('AthleteProfileCtrl', ['$rootScope', '$log', '$translate', 'dataService', 'sportContextService', 'navService', function ($rootScope, $log, $translate, dataService, sportContextService, navService) {

    var vm = this;
    vm.loading = { value: 0 };

    vm.error = { message: '' };
    var err = vm.error;

    var page = $rootScope.getNavigator().getCurrentPage();

    navService.push({ title: $translate.instant('Profile'), controlContext: false });


    var athleteId = page.options.athleteId; //101; //(lindsey vonn, who has the most info) //

    // Mock data
    //vm.athlete =
    //{
    //    "id": 101,
    //    "image_url": "http://data.fis-ski.com/dynamic/load-competitor-picture/30368.html",
    //    "fis_code": 537544,
    //    "name": "VONN Lindsey",
    //    "gender": "W",
    //    "country": "USA",
    //    "active": true,
    //    "dob": "1977-04-13T00:00:00",
    //    "social": [
    //        {
    //            "name": "www.awesome.com",
    //            "value": "http://www.awesome.com"
    //        }
    //    ],
    //    "equipment": [
    //        {
    //            "name": "Skiis",
    //            "value": "Rossignol"
    //        }
    //    ],
    //    "disciplines": [
    //        {
    //            "type": "DH",
    //            "rank": 1
    //        }
    //    ],
    //    "results": [
    //        {
    //            "position": '3',
    //            "date": '2016-11-30',
    //            "country": 'USA',
    //            "eventName": 'National Championships',
    //            "discipline_id": 'DH'
    //        },
    //        {
    //            "position": 'DNF',
    //            "date": '2016-11-24',
    //            "country": 'SUI',
    //            "eventName": 'FIS Race',
    //            "discipline_id": 'GS'
    //        },
    //        {
    //            "position": '10',
    //            "date": '2016-11-23',
    //            "country": 'USA',
    //            "eventName": 'FIS Race',
    //            "discipline_id": 'DH'
    //        }
    //    ]
    //};

    function getAthleteProfile() {
        vm.loading.value++;
        dataService.Athlete.get({ id: athleteId }, function success(athlete) {
            vm.loading.value--;
            vm.athlete = athlete;
            vm.athlete.social = vm.athlete.social.map(function (item) {
                switch (item.id) {
                    //website
                    case 1:
                        item.icon = "fa-globe";
                        item.type = "website";
                        break;
                    //blog
                    case 2:
                        item.icon = "fa-rss";
                        item.type = "blog";
                        break;
                    //facebook
                    case 3:
                        item.icon = "fa-facebook-square";
                        item.type = "facebook";
                        break;
                    //twitter
                    case 4:
                        item.icon = "fa-twitter";
                        item.type = "twitter";
                        break;
                    //instagram
                    case 5:
                        item.icon = "fa-instagram";
                        item.type = "instagram";
                        break;
                    //vlog
                    case 6:
                        item.icon = "fa-video-camera";
                        item.type = "vlog";
                        break;
                    //snapchat
                    case 7:
                        item.icon = "fa-snapchat";
                        item.type = "snapchat";
                        break;
                    default:
                        item.icon = "fa-globe";
                        item.type = "website";
                        break;
                }
                return item;
            });
        }, function error(e) {
            vm.loading.value--;
            $log.debug('Error:' + JSON.stringify(e));
            err.message = e.data ? e.data.Message : 'Error Retrieving Athlete';
        });
    }

    this.viewHistory = function () {
        $rootScope.pushPage('partials/athletes/history.html', { athleteId: athleteId });
        navService.push({ title: $translate.instant('History'), controlContext: false });
    };

    function init() {
        getAthleteProfile();
    };

    init();

}]);