module.controller('ChallengesCtrl', ['$log', '$rootScope', '$scope', '$routeParams', '$filter', '$translate', 'TourService', 'LocalNotificationService', 'dataService', 'navService',
	function ($log, $rootScope, $scope, $routeParams, $filter, $translate, TourService, LocalNotificationService, dataService, navService) {
	$scope.error = {
		message: ""
	};
	$scope.challenges = [];
	$scope.pageLoading = 0;
	navService.initializeStack({ title: $translate.instant('Challenges'), controlContext: true });

	//---IO functions----
	loadChallenges();
	function loadChallenges() {
	    $scope.pageLoading++;
	    var date = $filter('date')(new Date(), 'yyyy-MM-dd');
		dataService.Challenge.query({ curdate: date }, function success(challenges) {
		    $scope.challenges = challenges;

		    LocalNotificationService.UpdateChallengeNotifications($scope.challenges);

			$scope.pageLoading--;

			TourService.Start("challenges");

		}, function error(err) {
			$scope.pageLoading--;
			$log.debug('Err:' + JSON.stringify(err));
			$scope.error.message = err.data ? err.data.Message : 'Error Retrieving User Challenges';
		});
	};

	//UI functions------------
}]);
