module.controller('ChallengesRacesCtrl', ['$log', '$rootScope', '$scope', '$routeParams', '$location', '$translate', 'AuthService', 'AccountService', 'TranslationService', 'dataService', 'navService',
	function ($log, $rootScope, $scope, $routeParams, $location, $translate, AuthService, AccountService, TranslationService, dataService, navService) {
	$scope.error = {
		message: ""
	};
	$scope.pageLoading = 0;

	var page = $rootScope.getNavigator().getCurrentPage();
	$scope.pageLoading = 0;
	$scope.challenge = page.options.challenge;

    //---IO functions----
    loadRaces();
    function loadRaces(){
    	$scope.pageLoading++;
    	if ($scope.challenge.club_id) {
    		dataService.UserRace.query(function success(races) {
    			$scope.userRaces = races;
    			scrollToRecentRace();
    			$scope.pageLoading--;

    		}, function error(err) {
    			$scope.pageLoading--;
    			$log.debug('Err:' + JSON.stringify(err));
    			$scope.error.message = err.data ? err.data.Message : 'Error Retrieving Races';
    		});
    	} else {
    		dataService.Challenge.getRaces({ id: $scope.challenge.id }, function success(races) {
    			$scope.userRaces = races;
    			scrollToRecentRace();
    			$scope.pageLoading--;

    		}, function error(err) {
    			$scope.pageLoading--;
    			$log.debug('Err:' + JSON.stringify(err));
    			$scope.error.message = err.data ? err.data.Message : 'Error Retrieving Races';
    		});
    	}
    };

    //UI functions------------
    $scope.closestRacePosition = null;
    function scrollToRecentRace() {
        //determine the height of the elements
        var distance;
        var closestRace = null;
        var currentDate = new Date();
        $scope.userRaces.forEach(function (item) {
            var thisDistance = Math.abs(new Date(Date.parse(item.race.race_date)) - currentDate);
            if (!distance || thisDistance < distance) {
                distance = thisDistance;
                closestRace = item;
            }
        })
        var position = $scope.userRaces.indexOf(closestRace) + 1;
        // get item height, no jQuery
        $scope.closestRacePosition = position;
    };

    $scope.selectRace = function (userRace) {
        // 1 - Completed race - Review
        if (userRace.race.completed) {
            $rootScope.pushPage('partials/races/result.html', { race: userRace });
            navService.push({ title: $translate.instant('Results'), controlContext: false });
        }
            // 2 - Race in progress - Follow
        else if (userRace.isLive && !userRace.race.completed) {
            $rootScope.pushPage('partials/races/live-result.html', { race: userRace });
            navService.push({ title: $translate.instant('Live Results'), controlContext: false });
        }
            // 3 - Race has yet to occur - Pick
        else {
            $rootScope.pushPage('partials/races/pick.html', { race: userRace, races: $scope.userRaces });
            navService.push({ title: $translate.instant('My Picks'), controlContext: false });
        }
    };

}]);
