module.controller('ClubProfileCtrl', ['$element', '$filter', '$log', '$rootScope', '$scope', '$routeParams', '$location', 'dataService',
	function ($element, $filter, $log, $rootScope, $scope, $routeParams, $location, dataService) {
	$scope.error = {
		message: ""
	};

	var page = $rootScope.getNavigator().getCurrentPage();
	$scope.pageLoading = 0;
	$scope.club = page.options.club;
	$scope.members = [];

    //---IO functions----
    loadUsers();
    function loadUsers() {
    	$scope.pageLoading++;
    	dataService.Club.leaders({ id: $scope.club.id }, function success(data) {
    	    $scope.members = $filter('orderBy')(data.leaders, 'user.rank');
    	    for (var i = 0; i < data.score_contributor_count; i++) {
    	        if ($scope.members[i] && $scope.members[i].user) {
    	            $scope.members[i].user.highlight = true;
    	        }
    	    }
        	$scope.pageLoading--;

        },function error(err){
        	$scope.pageLoading--;
            $log.debug('Err:' + JSON.stringify(err));
            $scope.error.message = err.data ? err.data.Message : 'Error Retrieving Club Members';
        });
    };
}]);
