﻿var module = angular.module('fsrTopTenControllers', []);

module.controller('AppCtrl', ['$rootScope', '$scope', '$routeParams', '$location', '$timeout', '$location', '$translate', 'AuthService', 'AppStateService', 'socialService', function ($rootScope, $scope, $routeParams, $location, $timeout, $location, $translate, AuthService, AppStateService, socialService) {
    $rootScope.loading = 0;
    $rootScope.isMobile = typeof cordova != 'undefined';

    $rootScope.openInAppBrowser = function (url) {
        window.open(url, '_blank', 'location=no,toolbarposition=top,clearcache=yes,clearsessioncache=yes,presentationstyle=pagesheet');
    };

    $rootScope.handleError = function (message) {
        $rootScope.alert(
            $translate.instant(message || "Something went wrong, please try again."),
            function () { },
            $translate.instant('Error'),
            $translate.instant('OK')
        );
    };

    $rootScope.alert = function (message, callback, title, buttonLabels) {
        if ($rootScope.isMobile) {
            navigator.notification.alert(
                message,
                function (index) { callback(index - 1) },
                title,
                buttonLabels
            );
        }
        else {
            ons.notification.alert({
                message: message,
                callback: callback,
                title: title,
                buttonLabels: buttonLabels
            });
        }
    };

    $rootScope.confirm = function (message, callback, title, buttonLabels) {
        if ($rootScope.isMobile) {
            navigator.notification.confirm(
                message,
                function (index) { callback(index - 1) },
                title,
                buttonLabels.join()
            );
        }
        else {
            //push picks forward for all future races
            ons.notification.confirm({
                message: message,
                callback: callback,
                title: title,
                buttonLabels: buttonLabels
            });
        }

    };

    $rootScope.getNavigator = function () {
        return $scope.onsNavigator;
    };

    $rootScope.back = function () {
        if ($routeParams.tab) {
            var search = $location.search();
            var newDepth = 0;
            if (search.d) {
                var currentDepth = parseInt(search.d);
                if (currentDepth > 1) {
                    newDepth = currentDepth - 1;
                    search.d = (newDepth).toString();
                }
                else {
                    search.d = null;
                }
            }
            else {
                search.d = null;
            }
            AppStateService.setDepth(newDepth);
            $location.search(search);
        }

        if ($rootScope.getNavigator().getPages().length > 0) {
            $rootScope.getNavigator().popPage();
        }
        else {
            AppStateService.setDepth(0);
        }
    };

    $rootScope.navigateTo = function (page, options) {
        if ($routeParams.tab) {
            var search = $location.search();
            if (search.d) {
                search.d = (parseInt(search.d) + 1).toString();
            }
            else {
                search.d = "1";
            }
            $location.search(search);
        }
        if (options) {
            $rootScope.getNavigator().pushPage(page, options);
        }
        else {
            $rootScope.getNavigator().pushPage(page);
        }
    };

    $rootScope.popPage = function () {
        $rootScope.back();
    };

    $rootScope.pushPage = function (page, options) {
        return $rootScope.navigateTo(page, options);
    };

    $scope.safeApply = function (fn) {
    	var phase = this.$root.$$phase;
    	if (phase == '$apply' || phase == '$digest') {
    		if (fn && (typeof (fn) === 'function')) {
    			fn();
    		}
    	} else {
    		this.$apply(fn);
    	}
    };

    $scope.isTabActive = function (index) {
        return AppStateService.getTab() == index;
    };

    document.addEventListener("backbutton", function (e) {
        if ($rootScope.getNavigator().getPages().length > 1) {
            $scope.back();
        } else {
            $rootScope.ons.screen.dismissPage();
        }
    }, false);


    $scope.enqueueNotification = function () {
        return;

        var raceDate = new Date();
        raceDate.setDate(raceDate.getDate() + 1);
        raceDate.setMinutes(raceDate.getMinutes() + 1);
        LocalNotificationService.UpdateRaceNotifications([{ pickCount: 0, race: { id: 268, name: "Soelden - Women's Giant Slalom", race_date: raceDate.getTime() } }]);

        var challengeDate = new Date();
        challengeDate.setMinutes(challengeDate.getMinutes() + 1);
        LocalNotificationService.UpdateChallengeNotifications([{ id: 13, name: "FSR Champions Season Challenge", joined: true, end_date: challengeDate.getTime() }]);

        alert('test notifications set');
    };

    $scope.setTestContext = function () {
        return;
        //$rootScope.$broadcast("notification:local", { data: { type: "race", id: 268 } });
        //$rootScope.$broadcast("notification:local", { data: { type: "challenge", id: 13 } });
        $rootScope.$broadcast("notification:local", { data: { type: "social", id: "search" } });
        //$rootScope.$broadcast("notification:local", { data: { type: "league", id: 2074 } });
    };

    // handle a local notification
    $scope.$on("notification:local", function (event, notification) {
        //alert("on:" + notification.data.type + ":" + notification.data.id);

        var tabIndex = -1;
        switch (notification.data.type) {
            case "league":
                // leagues tab index is 0
                tabIndex = 0;
                break;
            case "race":
                // races tab index is 1
                tabIndex = 1;
                break;
            case "challenge":
                // challenges tab index is 2
                tabIndex = 2;
                break;
            case "social":
                // challenges tab index is 3
                tabIndex = 3;
                break;
            case "usage":
                // no need to set a tab or context here
                break;
            default:
                break;
        }
        if (tabIndex >= 0) {
            if (typeof(tabbar) != 'undefined' && tabbar._scope) {
                // change the tab if the tabbar is active
                tabbar.setActiveTab(tabIndex);
            }
            else {
                // set the active tab index
                AppStateService.setTab(tabIndex);
            }
            // set the ActiveTabContext (this will be a race id, challenge id, etc)
            // each time the setTab is called, this will be cleared
            AppStateService.setTabContext(notification.data.id);
            
            $timeout(function () {
                // broadcast the event just in case the user is already on the tab in question
                $rootScope.$broadcast("notification:local:" + notification.data.type, notification);
            }, 100);
        }
    });


    $scope.$on("sport:contextchanged", function (event, data) {
        if (typeof (tabbar) != 'undefined' && tabbar._scope) {
            // change the tab if the tabbar is active
            tabbar.setActiveTab(data.tabIndex);
        }
        else {
            // set the active tab index
            AppStateService.setTab(data.tabIndex);
        }
    });

    //---EVENTS---
    $scope.$watch('tabbar',
        function(newVal, oldVal) {
            if (!newVal) return;

            // set the active tab if it's not already set
            if (tabbar.getActiveTabIndex() < 0) {
                tabbar.setActiveTab(AppStateService.getTab());
            }

            // save the state each time the tab changes
            tabbar.on("postchange",
                function(e) {
                    if (e.tabItem.isActive()) {
                        AppStateService.setTab(e.index);
                        switch (e.index)
                        {
                            case 0:
                                tab = "leagues";
                                break;
                            case 1:
                                tab = "races";
                                break;
                            case 2:
                                tab = "challenges";
                                break;
                            case 3:
                                tab = "social";
                                break;
                            case 4:
                                tab = "settings";
                                break;
                        }
                        $location.search({});
                        $location.path("/dashboard/" + tab);
                    }
                });
        });
}]);

module.controller('WelcomeCtrl', ['$rootScope', '$scope', '$location', '$translate', 'TranslationService', 'AuthService', 'LocalNotificationService', 'AppStateService', 'navService',
    function ($rootScope, $scope, $location, $translate, TranslationService, AuthService, LocalNotificationService, AppStateService, navService) {

        navService.initializeStack({ title: $translate.instant('Welcome'), controlContext: false });

    	$scope.select = { languages: [] };
    	$scope.language = { selected: TranslationService.getLanguage() };

    	TranslationService.getLanguages().then(function (response) {
    		$scope.select.languages = response.data;
    	}, function (err) {

    	});

        $scope.changeLanguage = function () {
            TranslationService.changeLanguage($scope.language.selected);
        };

        $scope.register = function () {
            $rootScope.pushPage('partials/login/register.html', {});
            navService.push({ title: $translate.instant('Sign up'), controlContext: false });
        };

        $scope.logIn = function () {
            $rootScope.pushPage('partials/login/login.html', {});
            navService.push({ title: $translate.instant('Log In'), controlContext: false });
        };

    }
])
;

module.controller('LoginCtrl', ['$timeout', '$rootScope', '$scope', '$routeParams', '$storage', '$location', '$timeout', '$translate', 'dataService', 'AuthService', 'TranslationService', 'navService', function ($timeout, $rootScope, $scope, $routeParams, $storage, $location, $timeout, $translate, dataService, AuthService, TranslationService, navService) {
	$scope.select = { countries: [], languages: [], clubs: [] };

    TranslationService.getLanguages().then(function (response) {
    	$scope.select.languages = response.data;
    }, function (err) {
    });

    TranslationService.getCountries().then(function (response) {
        $scope.select.countries = response.data;
    }, function (err) {
    });

    $scope.result = {
        success: false,
        message: ""
    };

    $scope.error = {message: ''};

    $scope.registration = {
        email: "",
        username: "",
        password: "",
        passwordVerify: "",
        country: "USA",
        language: TranslationService.getLanguage(),
        name: "",
        dateofbirth: "",
        gender: "",
        ussaId: "",
		clubId: -1
    };

    $scope.loginData = {
        username: "",
        password: ""
    };

    $scope.forgotData = {
        usernameOrEmail: ""
    };


    var THROTTLE = 500; // throttle to only search after 500ms of inactivity
    var lastSearch;
    var nextSearchFn;
    $scope.findRelatedClubs = function () {
        if (lastSearch && (new Date() - lastSearch < THROTTLE)) {
            // if there is already a search, cancel it
            if (nextSearchFn) clearTimeout(nextSearchFn);

            // set the next search
            nextSearchFn = setTimeout(function () {
                clubSearch();
            }, THROTTLE);
        }
        else {
            clubSearch();
        }
    };

    function clubSearch() {
    	dataService.Club.getByUssaId({ id: $scope.registration.ussaId }, function success(data) {
    		$scope.select.clubs = data;
    	}, function error(err) {
    		$log.debug('Err:' + JSON.stringify(err));
    		$scope.error.message = err.data ? err.data.Message : 'Error Searching';
    	});
    	lastSearch = new Date();
    }

    $scope.forgotPassword = function() {
        $rootScope.pushPage('partials/login/forgot.html', {});
        navService.push({ title: $translate.instant('Forgot Password'), controlContext: false });
    };

    $scope.register = function () {
        $scope.submitted = true;
        if ($scope.form && $scope.form.$invalid) {
            $scope.result.success = false;
            $scope.result.message = "Missing required information.";
            return;
        }

        if ($scope.registration.password != $scope.registration.passwordVerify) {
            $scope.result.success = false;
            $scope.result.message = "Passwords must match.";
            return;
        }

        $rootScope.loading++;
        AuthService.register($scope.registration).then(
            function (response) {
                $rootScope.loading--;
                $scope.result.success = true;
                $scope.result.message = "WELCOME";
                $scope.loginData = {
                    username: $scope.registration.username,
                    password: $scope.registration.password
                };

                $scope.login();
            },
            function (err) {
                $rootScope.loading--;
                $scope.result.success = false;
                $scope.result.message = err.data.Message;
            });
    };
    $scope.registerFacebook = function () {
        $rootScope.loading++;
        $scope.loginData.externalaccesstoken = $storage.get('fb_token');
        $scope.loginData.provider = 'facebook';
        $scope.loginData.language = $storage.get('lang');
        AuthService.facebook_register($scope.loginData,
            function success(resp) {
                $rootScope.loading--;
                $scope.signinFacebook($scope.loginData.externalaccesstoken, true);
            }, function error(err) {
                $scope.error.message = err;
                $rootScope.loading--;
            });
    };
    function connectFacebook(username) {
    	$rootScope.loading++;
    	$scope.loginData.externalaccesstoken = $storage.get('fb_token');
    	$scope.loginData.provider = 'facebook';
    	$scope.loginData.language = $storage.get('lang');
    	$scope.loginData.username = username;
    	AuthService.facebook_connect($scope.loginData,
            function success(resp) {
            	$rootScope.loading--;
            	$scope.signinFacebook($scope.loginData.externalaccesstoken);
            }, function error(err) {
            	$rootScope.loading--;
            });
    };

    //--------------------------------------
    //FACEBOOK  -- MIGHT WANT TO MOVE
    $scope.signinFacebook = function (token, forceNav) {
        $rootScope.loading++;
        if (!token) {
            facebookConnectPlugin.login(["email", "user_location", "user_friends"]
                , function success(info) {
                    if (info.status == 'connected') {
                        //access granted
                        _doLogin(info.authResponse.accessToken);
                    }
                }, function error(e) {
                    $timeout(function () {
                        $rootScope.loading--;
                    })

                })
        }
        else {
            _doLogin(token);
        }

        function _doLogin(token) {
            AuthService.facebookLogin(token, {
                success: function (result) {
                    $rootScope.loading--;
                    $rootScope.$broadcast('facebook-connected');
                    if (forceNav) $location.path('/');
                }, doRegister: function () {
                    $rootScope.loading--;
                    var loggedInUser = AuthService.getUserData();
                    if (loggedInUser && loggedInUser.username != "") {
                        connectFacebook(loggedInUser.username);
                    }
                    else {
                        $rootScope.pushPage('partials/login/register-facebook.html');
                    }
                }, error: function (err) {
                    $rootScope.loading--;
                    $scope.result.success = false;
                    $scope.result.message = err.Message;
                }
            });
        }

    };
    //--------END OF FACEBOOK----------------
    //---------------------------------------
    $scope.login = function () {
        $scope.submitted = true;
        if ($scope.form && $scope.form.$invalid) {
            $scope.result.success = false;
            $scope.result.message = "Missing required information.";
            return;
        }

        $rootScope.loading++;

        AuthService.login($scope.loginData).then(
            function (response) {
                $rootScope.loading--;
                $scope.result.success = true;
                $scope.result.message = "WELCOME";
                $location.path('/dashboard');
            },
            function (err) {
                $rootScope.loading--;
                $scope.result.success = false;
                $scope.result.message = err.error_description;
            });
    };

    $scope.forgot = function () {
        $scope.submitted = true;
        if ($scope.form && $scope.form.$invalid) {
            $scope.result.success = false;
            $scope.result.message = "Missing required information.";
            return;
        }

        $rootScope.loading++;

        AuthService.reset($scope.forgotData).then(
            function (response) {
                $rootScope.loading--;
                $scope.result.success = true;
                $scope.result.message = $scope.forgotData.usernameOrEmail + ", you've got mail!";
                $timeout(function () {
                    $rootScope.getNavigator().popPage();
                }, 1500);
            },
            function (err) {
                $rootScope.loading--;
                $scope.result.success = false;
                $scope.result.message = err.data.Message;
            });
    };
}]);

