module.controller('LeagueCreateCtrl', ['$rootScope', '$scope', '$routeParams', '$location', '$timeout', '$storage', '$translate', 'AuthService', 'AccountService', 'TranslationService', 'dataService', 'navService', function ($rootScope, $scope, $routeParams, $location, $timeout, $storage, $translate, AuthService, AccountService, TranslationService, dataService, navService) {
    $scope.error = {
        message: ""
    };
    //get the users id
    var currentUser = $storage.get('userData');
    $scope.currentUser = currentUser;

    //---Scope Properties
    $scope.league = null;

    //---UI functions----
    $scope.cancel = cancel;
    function cancel() {
        $scope.popPage();
    }

    $scope.create = create;
    function create() {
        $scope.submitted = true;
        if ($scope.form.$invalid) {
            $scope.error.message = "Missing required information.";
            return;
        }
        $rootScope.loading++;

        dataService.Leagues.save({}, $scope.league,
            function success(data) {
                $rootScope.pushPage('partials/leagues/invite.html', {
                    animation: 'lift' // What animation to use
                    ,leagueId:data.id
                    ,isNewLeague:true
                });
                navService.push({ title: $translate.instant('Invite'), controlContext: false });
                $rootScope.loading--;
        }, function err() {
                $scope.error.message = "Error creating league.";
                $rootScope.loading--;
        });

    }
}]);
