module.controller('RaceResultLeaderCtrl', ['$log', '$rootScope', '$scope', '$routeParams', '$location', '$storage', 'TranslationService', 'AppStateService', 'dataService', function ($log, $rootScope, $scope, $routeParams, $location, $storage, TranslationService, AppStateService, dataService) {
    $scope.error = {
		message: ""
	};
    $scope.pageLoading = 0;
    $scope.leaders = [];
    var page = $rootScope.getNavigator().getCurrentPage();
    $scope.raceId = page.options.raceId;
    $scope.leaderType = page.options.leaderType;
    $scope.contentTitle = page.options.contentTitle;

    loadLeaders();

    //---IO functions----
    function loadLeaders() {
        $scope.pageLoading++;
        switch ($scope.leaderType) {
            case "League":
                dataService.UserRaceResults.leaders({ id: $scope.raceId, leaderType: $scope.leaderType.toLowerCase(), leagueId: AppStateService.getLeagueId() }, onSuccess, onError);
                break;
            default:
                dataService.UserRaceResults.leaders({ id: $scope.raceId, leaderType: $scope.leaderType.toLowerCase() }, onSuccess, onError);
                break;
        }
    }

    function onSuccess(data) {
        $scope.leaders = data;
        $scope.pageLoading--;
    }

    function onError(err) {
        $scope.pageLoading--;
        $log.debug('Err:' + JSON.stringify(err));
        $scope.error.message = err.data ? err.data.Message : 'Error Retrieving Races';
    }
}]);
