module.controller('SocialProfileCtrl', ['$element', '$filter', '$log', '$rootScope', '$scope', '$routeParams', '$location', '$translate', 'AuthService', 'AccountService', 'TranslationService', 'dataService', 'navService',
	function ($element, $filter, $log, $rootScope, $scope, $routeParams, $location, $translate, AuthService, AccountService, TranslationService, dataService, navService) {
	    $scope.error = {
		    message: ""
	    };

	    var page = $rootScope.getNavigator().getCurrentPage();
	    $scope.pageLoading = 0;
        $scope.user = page.options.user;

	        //---IO functions----
        loadRaces();
        function loadRaces(){
    	    $scope.pageLoading++;
    	    dataService.UserRace.query({ id: $scope.user.user_id }, function success(races) {
    	        $scope.races = races;
    	        var racesCopy = JSON.parse(JSON.stringify($scope.races));
        	    $scope.reversedRaces = racesCopy.reverse();
        	    $scope.pageLoading--;
                
            },function error(err){
        	    $scope.pageLoading--;
                $log.debug('Err:' + JSON.stringify(err));
                $scope.error.message = err.data ? err.data.Message : 'Error Retrieving Races';
            });
        };

	    //UI functions------------
       
        $scope.selectRace = function (userRace) {
            // 1 - Completed race - Review
            if (userRace.race.completed) {
                $rootScope.pushPage('partials/races/result.html', { userId: $scope.user.user_id, race: userRace });
                navService.push({ title: $translate.instant('Results'), controlContext: false });
            }
                // 2 - Race in progress - Follow
            else if (userRace.isLive && !userRace.race.completed) {
                $rootScope.pushPage('partials/races/live-result.html', { userId: $scope.user.user_id, race: userRace });
                navService.push({ title: $translate.instant('Live Results'), controlContext: false });
            }
                // 3 - Race has yet to occur - Pick
            else {
                $rootScope.pushPage('partials/races/pick.html', { userId: $scope.user.user_id, race: userRace, races: $scope.userRaces });
                navService.push({ title: $translate.instant('My Picks'), controlContext: false });
            }
        };

        $scope.isComplete = isComplete;
        function isComplete(value, index) {
    	    return value.race.completed;
        }

}]);
