module.directive('fsrAthletePhoto', ['$timeout', function ($timeout) {
    return {
        restrict: 'E',
        replace: true,
        template: '<span class="athlete-photo athlete-photo-background"></span>',
        scope: {
            athlete: '='
        },
        link: function (scope, element, attrs) {
            scope.$watch(
		        function (scope) {
		            return scope.athlete;
		        },
		        function (newValue, oldValue) {
		            if (newValue && newValue !== oldValue) {
		                scope.updatePhoto();
		            }
		        });

            scope.updatePhoto = function () {
                if (scope.athlete && scope.athlete.image_url) {
                    $(element).css('background-image', 'url(' + scope.athlete.image_url + ')');
                }
                else {
                    // just leave it blank?
                }
            };
            scope.updatePhoto();
        }
    };
}]);