module.directive('fsrClubProfileItem', ['$timeout', function ($timeout) {
    return {
        restrict: 'E',
        replace: false,
        templateUrl: './templates/directives/fsr-clubProfileItem.html',
        scope: {
        	club: '=',
        	score: '=',
        	minimal: '='
        },
        transclude: true,
        controller: ['$rootScope', '$scope', 'navService', function ($rootScope, $scope, navService) {

        	$scope.view = function (club) {
        	    var currentPage = $rootScope.getNavigator().getCurrentPage();
                if (currentPage.options && currentPage.options.club && currentPage.options.club.user_id == club.user_id) {
                    // don't do anything, the current user's profile is already at the top of the display stack
                }
                else
                {
                    $rootScope.pushPage('partials/club/profile.html', { club: club });
                    navService.push({ title: $scope.club.name, controlContext: false });
                }
        	};
        }],
        link: function (scope, element, attrs) {

        }
    };
}]);