module.directive('fsrCounter', ['$timeout',function ($timeout) {
    return {
        restrict: 'E',
        replace: false,
        scope: {
        	count: '=',
        	theme: '=',
			format: '='
        },
        link: function ($scope, $element, $attrs) {
        	//Ensure values on scope
        	var theme = (typeof $scope.theme == "undefined") ? 'minimal' : $scope.theme;
        	var count = (typeof $scope.count == "undefined") ? 0 : $scope.count;
        	var format = (typeof $scope.format == "undefined") ? 'd' : $scope.format;

			//Initialize
        	$scope.odometer = new Odometer({ el: $element[0], theme: theme, value: count, format: format });
        	$scope.odometer.render();

        	//Events
        	$scope.$watch(
				function (scope) {
					return scope.count;
				},
				function (newValue, oldValue) {
					if (newValue != oldValue) {
						$scope.odometer.update(newValue);
					}
				}
			);
        }
    };
}]);