module.directive('fsrFlagCountry', ['$timeout',function ($timeout) {
    return {
        restrict: 'A',
        replace: false,
        scope: {
            country: '='
        },
        link: function (scope, element, attrs) {
            scope.$watch(
		        function (scope) {
		            return scope.country;
		        },
		        function (newValue, oldValue) {
		            if (newValue && newValue !== oldValue) {
		                scope.update(newValue);
		            }
		        });

            scope.update = function (code) {
                var countryCodes = _countryCodes();

                var flagClass = 'flag-icon-fsr';
                var convertedCode = '';
                if (code) {
                    if (code.length === 3) {
                        countryCodes.some(function (item) {
                            if (item.abbr == code.toUpperCase()) {
                                convertedCode = item;
                            }
                        });
                    }

                    else if (code.length === 2) {
                        convertedCode = { code: code };
                    }

                    if (convertedCode) {
                        flagClass = 'flag-icon-' + convertedCode.code.toLocaleLowerCase();
                    }
                }

                $(element).removeClass('flag-icon-fsr').addClass(flagClass);

                //---Lookup

                function _countryCodes() {
                    return [
                        { "code": "af", "abbr": "AFG", "name": "Afghanistan" },
                        { "code": "al", "abbr": "ALB", "name": "Albania" },
                        { "code": "dz", "abbr": "DZA", "name": "Algeria" },
                        { "code": "as", "abbr": "ASM", "name": "American Samoa" },
                        { "code": "ad", "abbr": "AND", "name": "Andorra" },
                        { "code": "ao", "abbr": "AGO", "name": "Angola" },
                        { "code": "ai", "abbr": "AIA", "name": "Anguilla" },
                        { "code": "aq", "abbr": "ATA", "name": "Antarctica" },
                        { "code": "ag", "abbr": "ATG", "name": "Antigua and Barbuda" },
                        { "code": "ar", "abbr": "ARG", "name": "Argentina" },
                        { "code": "am", "abbr": "ARM", "name": "Armenia" },
                        { "code": "aw", "abbr": "ABW", "name": "Aruba" },
                        { "code": "au", "abbr": "AUS", "name": "Australia" },
                        { "code": "at", "abbr": "AUT", "name": "Austria" },
                        { "code": "az", "abbr": "AZE", "name": "Azerbaijan" },
                        { "code": "bs", "abbr": "BHS", "name": "Bahamas" },
                        { "code": "bh", "abbr": "BHR", "name": "Bahrain" },
                        { "code": "bd", "abbr": "BGD", "name": "Bangladesh" },
                        { "code": "bb", "abbr": "BRB", "name": "Barbados" },
                        { "code": "by", "abbr": "BLR", "name": "Belarus" },
                        { "code": "be", "abbr": "BEL", "name": "Belgium" },
                        { "code": "bz", "abbr": "BLZ", "name": "Belize" },
                        { "code": "bj", "abbr": "BEN", "name": "Benin" },
                        { "code": "bm", "abbr": "BMU", "name": "Bermuda" },
                        { "code": "bt", "abbr": "BTN", "name": "Bhutan" },
                        { "code": "bo", "abbr": "BOL", "name": "Bolivia" },
                        { "code": "bq", "abbr": "BES", "name": "Bonaire" },
                        { "code": "ba", "abbr": "BIH", "name": "Bosnia and Herzegovina" },
                        { "code": "bw", "abbr": "BWA", "name": "Botswana" },
                        { "code": "bv", "abbr": "BVT", "name": "Bouvet Island" },
                        { "code": "br", "abbr": "BRA", "name": "Brazil" },
                        { "code": "io", "abbr": "IOT", "name": "British Indian Ocean Territory" },
                        { "code": "bn", "abbr": "BRN", "name": "Brunei Darussalam" },
                        { "code": "bg", "abbr": "BGR", "name": "Bulgaria" },
                        { "code": "bf", "abbr": "BFA", "name": "Burkina Faso" },
                        { "code": "bi", "abbr": "BDI", "name": "Burundi" },
                        { "code": "kh", "abbr": "KHM", "name": "Cambodia" },
                        { "code": "cm", "abbr": "CMR", "name": "Cameroon" },
                        { "code": "ca", "abbr": "CAN", "name": "Canada" },
                        { "code": "cv", "abbr": "CPV", "name": "Cape Verde" },
                        { "code": "ky", "abbr": "CYM", "name": "Cayman Islands" },
                        { "code": "cf", "abbr": "CAF", "name": "Central African Republic" },
                        { "code": "td", "abbr": "TCD", "name": "Chad" },
                        { "code": "cl", "abbr": "CHL", "name": "Chile" },
                        { "code": "cn", "abbr": "CHN", "name": "China" },
                        { "code": "cx", "abbr": "CXR", "name": "Christmas Island" },
                        { "code": "cc", "abbr": "CCK", "name": "Cocos (Keeling) Islands" },
                        { "code": "co", "abbr": "COL", "name": "Colombia" },
                        { "code": "km", "abbr": "COM", "name": "Comoros" },
                        { "code": "cg", "abbr": "COG", "name": "Congo" },
                        { "code": "cd", "abbr": "COD", "name": "Democratic Republic of the Congo" },
                        { "code": "ck", "abbr": "COK", "name": "Cook Islands" },
                        { "code": "cr", "abbr": "CRI", "name": "Costa Rica" },
                        { "code": "hr", "abbr": "HRV", "name": "Croatia" },
                        { "code": "cu", "abbr": "CUB", "name": "Cuba" },
                        { "code": "cw", "abbr": "CUW", "name": "Curaçao" },
                        { "code": "cy", "abbr": "CYP", "name": "Cyprus" },
                        { "code": "cz", "abbr": "CZE", "name": "Czech Republic" },
                        { "code": "ci", "abbr": "CIV", "name": "Côte d'Ivoire" },
                        { "code": "dk", "abbr": "DNK", "name": "Denmark" },
                        { "code": "dj", "abbr": "DJI", "name": "Djibouti" },
                        { "code": "dm", "abbr": "DMA", "name": "Dominica" },
                        { "code": "do", "abbr": "DOM", "name": "Dominican Republic" },
                        { "code": "ec", "abbr": "ECU", "name": "Ecuador" },
                        { "code": "eg", "abbr": "EGY", "name": "Egypt" },
                        { "code": "sv", "abbr": "SLV", "name": "El Salvador" },
                        { "code": "gq", "abbr": "GNQ", "name": "Equatorial Guinea" },
                        { "code": "er", "abbr": "ERI", "name": "Eritrea" },
                        { "code": "ee", "abbr": "EST", "name": "Estonia" },
                        { "code": "et", "abbr": "ETH", "name": "Ethiopia" },
                        { "code": "fk", "abbr": "FLK", "name": "Falkland Islands (Malvinas)" },
                        { "code": "fo", "abbr": "FRO", "name": "Faroe Islands" },
                        { "code": "fj", "abbr": "FJI", "name": "Fiji" },
                        { "code": "fi", "abbr": "FIN", "name": "Finland" },
                        { "code": "fr", "abbr": "FRA", "name": "France" },
                        { "code": "gf", "abbr": "GUF", "name": "French Guiana" },
                        { "code": "pf", "abbr": "PYF", "name": "French Polynesia" },
                        { "code": "tf", "abbr": "ATF", "name": "French Southern Territories" },
                        { "code": "ga", "abbr": "GAB", "name": "Gabon" },
                        { "code": "gm", "abbr": "GMB", "name": "Gambia" },
                        { "code": "ge", "abbr": "GEO", "name": "Georgia" },
                        { "code": "de", "abbr": "DEU", "name": "Germany" },
                        { "code": "gh", "abbr": "GHA", "name": "Ghana" },
                        { "code": "gi", "abbr": "GIB", "name": "Gibraltar" },
                        { "code": "gr", "abbr": "GRC", "name": "Greece" },
                        { "code": "gl", "abbr": "GRL", "name": "Greenland" },
                        { "code": "gd", "abbr": "GRD", "name": "Grenada" },
                        { "code": "gp", "abbr": "GLP", "name": "Guadeloupe" },
                        { "code": "gu", "abbr": "GUM", "name": "Guam" },
                        { "code": "gt", "abbr": "GTM", "name": "Guatemala" },
                        { "code": "gg", "abbr": "GGY", "name": "Guernsey" },
                        { "code": "gn", "abbr": "GIN", "name": "Guinea" },
                        { "code": "gw", "abbr": "GNB", "name": "Guinea-Bissau" },
                        { "code": "gy", "abbr": "GUY", "name": "Guyana" },
                        { "code": "ht", "abbr": "HTI", "name": "Haiti" },
                        { "code": "hm", "abbr": "HMD", "name": "Heard Island and McDonald Mcdonald Islands" },
                        { "code": "va", "abbr": "VAT", "name": "Holy See" },
                        { "code": "hn", "abbr": "HND", "name": "Honduras" },
                        { "code": "hk", "abbr": "HKG", "name": "Hong Kong" },
                        { "code": "hu", "abbr": "HUN", "name": "Hungary" },
                        { "code": "is", "abbr": "ISL", "name": "Iceland" },
                        { "code": "in", "abbr": "IND", "name": "India" },
                        { "code": "id", "abbr": "IDN", "name": "Indonesia" },
                        { "code": "ir", "abbr": "IRN", "name": "Iran" },
                        { "code": "iq", "abbr": "IRQ", "name": "Iraq" },
                        { "code": "ie", "abbr": "IRL", "name": "Ireland" },
                        { "code": "ie", "abbr": "IRE", "name": "Ireland" },
                        { "code": "im", "abbr": "IMN", "name": "Isle of Man" },
                        { "code": "il", "abbr": "ISR", "name": "Israel" },
                        { "code": "it", "abbr": "ITA", "name": "Italy" },
                        { "code": "jm", "abbr": "JAM", "name": "Jamaica" },
                        { "code": "jp", "abbr": "JPN", "name": "Japan" },
                        { "code": "je", "abbr": "JEY", "name": "Jersey" },
                        { "code": "jo", "abbr": "JOR", "name": "Jordan" },
                        { "code": "kz", "abbr": "KAZ", "name": "Kazakhstan" },
                        { "code": "ke", "abbr": "KEN", "name": "Kenya" },
                        { "code": "ki", "abbr": "KIR", "name": "Kiribati" },
                        { "code": "kp", "abbr": "PRK", "name": "Korea, Democratic People's Republic of" },
                        { "code": "kr", "abbr": "KOR", "name": "Korea, Republic of" },
                        { "code": "kw", "abbr": "KWT", "name": "Kuwait" },
                        { "code": "kg", "abbr": "KGZ", "name": "Kyrgyzstan" },
                        { "code": "la", "abbr": "LAO", "name": "Lao People's Democratic Republic" },
                        { "code": "lv", "abbr": "LVA", "name": "Latvia" },
                        { "code": "lb", "abbr": "LBN", "name": "Lebanon" },
                        { "code": "ls", "abbr": "LSO", "name": "Lesotho" },
                        { "code": "lr", "abbr": "LBR", "name": "Liberia" },
                        { "code": "ly", "abbr": "LBY", "name": "Libya" },
                        { "code": "li", "abbr": "LIE", "name": "Liechtenstein" },
                        { "code": "lt", "abbr": "LTU", "name": "Lithuania" },
                        { "code": "lu", "abbr": "LUX", "name": "Luxembourg" },
                        { "code": "mo", "abbr": "MAC", "name": "Macao" },
                        { "code": "mk", "abbr": "MKD", "name": "Macedonia, the Former Yugoslav Republic of" },
                        { "code": "mg", "abbr": "MDG", "name": "Madagascar" },
                        { "code": "mw", "abbr": "MWI", "name": "Malawi" },
                        { "code": "my", "abbr": "MYS", "name": "Malaysia" },
                        { "code": "mv", "abbr": "MDV", "name": "Maldives" },
                        { "code": "ml", "abbr": "MLI", "name": "Mali" },
                        { "code": "mt", "abbr": "MLT", "name": "Malta" },
                        { "code": "mh", "abbr": "MHL", "name": "Marshall Islands" },
                        { "code": "mq", "abbr": "MTQ", "name": "Martinique" },
                        { "code": "mr", "abbr": "MRT", "name": "Mauritania" },
                        { "code": "mu", "abbr": "MUS", "name": "Mauritius" },
                        { "code": "yt", "abbr": "MYT", "name": "Mayotte" },
                        { "code": "mx", "abbr": "MEX", "name": "Mexico" },
                        { "code": "fm", "abbr": "FSM", "name": "Micronesia, Federated States of" },
                        { "code": "md", "abbr": "MDA", "name": "Moldova, Republic of" },
                        { "code": "mc", "abbr": "MCO", "name": "Monaco" },
                        { "code": "mn", "abbr": "MNG", "name": "Mongolia" },
                        { "code": "me", "abbr": "MNE", "name": "Montenegro" },
                        { "code": "ms", "abbr": "MSR", "name": "Montserrat" },
                        { "code": "ma", "abbr": "MAR", "name": "Morocco" },
                        { "code": "mz", "abbr": "MOZ", "name": "Mozambique" },
                        { "code": "mm", "abbr": "MMR", "name": "Myanmar" },
                        { "code": "na", "abbr": "NAM", "name": "Namibia" },
                        { "code": "nr", "abbr": "NRU", "name": "Nauru" },
                        { "code": "np", "abbr": "NPL", "name": "Nepal" },
                        { "code": "nl", "abbr": "NLD", "name": "Netherlands" },
                        { "code": "nc", "abbr": "NCL", "name": "New Caledonia" },
                        { "code": "nz", "abbr": "NZL", "name": "New Zealand" },
                        { "code": "ni", "abbr": "NIC", "name": "Nicaragua" },
                        { "code": "ne", "abbr": "NER", "name": "Niger" },
                        { "code": "ng", "abbr": "NGA", "name": "Nigeria" },
                        { "code": "nu", "abbr": "NIU", "name": "Niue" },
                        { "code": "nf", "abbr": "NFK", "name": "Norfolk Island" },
                        { "code": "mp", "abbr": "MNP", "name": "Northern Mariana Islands" },
                        { "code": "no", "abbr": "NOR", "name": "Norway" },
                        { "code": "om", "abbr": "OMN", "name": "Oman" },
                        { "code": "pk", "abbr": "PAK", "name": "Pakistan" },
                        { "code": "pw", "abbr": "PLW", "name": "Palau" },
                        { "code": "ps", "abbr": "PSE", "name": "Palestine, State of" },
                        { "code": "pa", "abbr": "PAN", "name": "Panama" },
                        { "code": "pg", "abbr": "PNG", "name": "Papua New Guinea" },
                        { "code": "py", "abbr": "PRY", "name": "Paraguay" },
                        { "code": "pe", "abbr": "PER", "name": "Peru" },
                        { "code": "ph", "abbr": "PHL", "name": "Philippines" },
                        { "code": "pn", "abbr": "PCN", "name": "Pitcairn" },
                        { "code": "pl", "abbr": "POL", "name": "Poland" },
                        { "code": "pt", "abbr": "PRT", "name": "Portugal" },
                        { "code": "pr", "abbr": "PRI", "name": "Puerto Rico" },
                        { "code": "qa", "abbr": "QAT", "name": "Qatar" },
                        { "code": "ro", "abbr": "ROU", "name": "Romania" },
                        { "code": "ru", "abbr": "RUS", "name": "Russia" },
                        { "code": "rw", "abbr": "RWA", "name": "Rwanda" },
                        { "code": "re", "abbr": "REU", "name": "Reunion" },
                        { "code": "bl", "abbr": "BLM", "name": "Saint Barthelemy" },
                        { "code": "sh", "abbr": "SHN", "name": "Saint Helena" },
                        { "code": "kn", "abbr": "KNA", "name": "Saint Kitts and Nevis" },
                        { "code": "lc", "abbr": "LCA", "name": "Saint Lucia" },
                        { "code": "mf", "abbr": "MAF", "name": "Saint Martin (French part)" },
                        { "code": "pm", "abbr": "SPM", "name": "Saint Pierre and Miquelon" },
                        { "code": "vc", "abbr": "VCT", "name": "Saint Vincent and the Grenadines" },
                        { "code": "ws", "abbr": "WSM", "name": "Samoa" },
                        { "code": "sm", "abbr": "SMR", "name": "San Marino" },
                        { "code": "st", "abbr": "STP", "name": "Sao Tome and Principe" },
                        { "code": "sa", "abbr": "SAU", "name": "Saudi Arabia" },
                        { "code": "sn", "abbr": "SEN", "name": "Senegal" },
                        { "code": "rs", "abbr": "SRB", "name": "Serbia" },
                        { "code": "sc", "abbr": "SYC", "name": "Seychelles" },
                        { "code": "sl", "abbr": "SLE", "name": "Sierra Leone" },
                        { "code": "sg", "abbr": "SGP", "name": "Singapore" },
                        { "code": "sx", "abbr": "SXM", "name": "Sint Maarten (Dutch part)" },
                        { "code": "sk", "abbr": "SVK", "name": "Slovakia" },
                        { "code": "si", "abbr": "SVN", "name": "Slovenia" },
                        { "code": "si", "abbr": "SLO", "name": "Slovenia" },
                        { "code": "sb", "abbr": "SLB", "name": "Solomon Islands" },
                        { "code": "so", "abbr": "SOM", "name": "Somalia" },
                        { "code": "za", "abbr": "ZAF", "name": "South Africa" },
                        { "code": "gs", "abbr": "SGS", "name": "South Georgia and the South Sandwich Islands" },
                        { "code": "ss", "abbr": "SSD", "name": "South Sudan" },
                        { "code": "es", "abbr": "ESP", "name": "Spain" },
                        { "code": "lk", "abbr": "LKA", "name": "Sri Lanka" },
                        { "code": "sd", "abbr": "SDN", "name": "Sudan" },
                        { "code": "sr", "abbr": "SUR", "name": "Suriname" },
                        { "code": "sj", "abbr": "SJM", "name": "Svalbard and Jan Mayen" },
                        { "code": "sz", "abbr": "SWZ", "name": "Swaziland" },
                        { "code": "se", "abbr": "SWE", "name": "Sweden" },
                        { "code": "ch", "abbr": "CHE", "name": "Switzerland" },
                        { "code": "sy", "abbr": "SYR", "name": "Syrian Arab Republic" },
                        { "code": "tw", "abbr": "TWN", "name": "Taiwan, Province of China" },
                        { "code": "tj", "abbr": "TJK", "name": "Tajikistan" },
                        { "code": "tz", "abbr": "TZA", "name": "United Republic of Tanzania" },
                        { "code": "th", "abbr": "THA", "name": "Thailand" },
                        { "code": "tl", "abbr": "TLS", "name": "Timor-Leste" },
                        { "code": "tg", "abbr": "TGO", "name": "Togo" },
                        { "code": "tk", "abbr": "TKL", "name": "Tokelau" },
                        { "code": "to", "abbr": "TON", "name": "Tonga" },
                        { "code": "tt", "abbr": "TTO", "name": "Trinidad and Tobago" },
                        { "code": "tn", "abbr": "TUN", "name": "Tunisia" },
                        { "code": "tr", "abbr": "TUR", "name": "Turkey" },
                        { "code": "tm", "abbr": "TKM", "name": "Turkmenistan" },
                        { "code": "tc", "abbr": "TCA", "name": "Turks and Caicos Islands" },
                        { "code": "tv", "abbr": "TUV", "name": "Tuvalu" },
                        { "code": "ug", "abbr": "UGA", "name": "Uganda" },
                        { "code": "ua", "abbr": "UKR", "name": "Ukraine" },
                        { "code": "ae", "abbr": "ARE", "name": "United Arab Emirates" },
                        { "code": "gb", "abbr": "GBR", "name": "United Kingdom" },
                        { "code": "us", "abbr": "USA", "name": "United States" },
                        { "code": "um", "abbr": "UMI", "name": "United States Minor Outlying Islands" },
                        { "code": "uy", "abbr": "URY", "name": "Uruguay" },
                        { "code": "uz", "abbr": "UZB", "name": "Uzbekistan" },
                        { "code": "vu", "abbr": "VUT", "name": "Vanuatu" },
                        { "code": "ve", "abbr": "VEN", "name": "Venezuela" },
                        { "code": "vn", "abbr": "VNM", "name": "Viet Nam" },
                        { "code": "vg", "abbr": "VGB", "name": "British Virgin Islands" },
                        { "code": "vi", "abbr": "VIR", "name": "US Virgin Islands" },
                        { "code": "wf", "abbr": "WLF", "name": "Wallis and Futuna" },
                        { "code": "eh", "abbr": "ESH", "name": "Western Sahara" },
                        { "code": "ye", "abbr": "YEM", "name": "Yemen" },
                        { "code": "zm", "abbr": "ZMB", "name": "Zambia" },
                        { "code": "zw", "abbr": "ZWE", "name": "Zimbabwe" },
                        { "code": "ax", "abbr": "ALA", "name": "Aland Islands" },

                        // these are the non-standard 3 letter codes used by FIS
                        { "code": "bg", "abbr": "BUL", "name": "Bulgaria" },
                        { "code": "cl", "abbr": "CHI", "name": "Chile" },
                        { "code": "hr", "abbr": "CRO", "name": "Croatia" },
                        { "code": "dk", "abbr": "DEN", "name": "Denmark" },
                        { "code": "de", "abbr": "GER", "name": "Germany" },
                        { "code": "nz", "abbr": "NZE", "name": "New Zealand" },
                        { "code": "ch", "abbr": "SUI", "name": "Switzerland" }
                    ];
                }
            }

            scope.update(attrs['fsrFlagCountry']);
        }
    };
}]);