module.directive('fsrIfPlatform', ['$timeout',function ($timeout) {
    return {
        restrict: 'A',
        replace: false,
        link:function(scope,element,attrs){
            
            element.addClass('ons-if-platform-inner');
            element.css('display', 'none');

            var platform = getPlatformString();

            attrs.$observe('onsIfPlatform', function (userPlatform) {
                if (userPlatform) {
                    update();
                }
            });

            update();

            function update() {
                if (attrs.fsrIfPlatform.toLowerCase().indexOf( platform.toLowerCase() ) > -1) {
                    element.css('display', 'block');
                } else {
                    element.css('display', 'none');
                }
            }

            function getPlatformString() {

                if (navigator.userAgent.match(/Android/i)) {
                    return 'android';
                }

                if ((navigator.userAgent.match(/BlackBerry/i)) || (navigator.userAgent.match(/RIM Tablet OS/i)) || (navigator.userAgent.match(/BB10/i))) {
                    return 'blackberry';
                }

                if (navigator.userAgent.match(/iPhone|iPad|iPod/i)) {
                    return 'ios';
                }

                if (navigator.userAgent.match(/IEMobile/i)) {
                    return 'windows';
                }

                // Opera 8.0+ (UA detection to detect Blink/v8-powered Opera)
                var isOpera = !!window.opera || navigator.userAgent.indexOf(' OPR/') >= 0;
                if (isOpera) {
                    return 'opera';
                }

                var isFirefox = typeof InstallTrigger !== 'undefined';   // Firefox 1.0+
                if (isFirefox) {
                    return 'firefox';
                }

                var isSafari = Object.prototype.toString.call(window.HTMLElement).indexOf('Constructor') > 0;
                // At least Safari 3+: "[object HTMLElementConstructor]"
                if (isSafari) {
                    return 'safari';
                }

                var isChrome = !!window.chrome && !isOpera; // Chrome 1+
                if (isChrome) {
                    return 'chrome';
                }

                var isIE = /*@cc_on!@*/false || !!document.documentMode; // At least IE6
                if (isIE) {
                    return 'ie';
                }

                return 'other';
            }

        }
    };
}]);