module.directive('fsrInfo', ['$timeout', '$templateCache', '$translate', function ($timeout, $templateCache, $translate) {
    return {
        restrict: 'E',
        replace: false,
        templateUrl: './templates/directives/fsr-info.html',
        transclude: true,
        scope: {
            contentTitle: '=?',
            dismissText: '=?',
            animation: '=?',
            theme: '=?',
            contentHtml: '=?'
        },
        link: function (scope, element, attrs, ctrl, transclude) {
            $(element).addClass('theme-' + scope.theme || 'dark');
            // replace the necessary tags with the attributes passed in
            element.find('content-element').replaceWith(transclude());
            if (scope.contentHtml) {
                element.find('content-html').replaceWith(scope.contentHtml.$$unwrapTrustedValue());
            }
            else {
                element.find('content-html').remove();
            }
            element.find('dismiss-text').replaceWith('<span>' + $translate.instant(scope.dismissText || 'Done') + '</span>');
            element.find('content-title').replaceWith('<span>' + $translate.instant(scope.contentTitle || '') + '</span>');

            // put the popup into the template cache so that the navigator can find it
            var popup = element.find('ons-page');
            $templateCache.put(scope.uuid, popup.remove().html());
        },
        controller: ['$rootScope', '$scope', function ($rootScope, $scope) {
            $scope.uuid = 'page-' + Math.random().toString(36).substr(2, 16) + '.html';
            $scope.open = function () {
                //$rootScope.pushPage('fsr-popup.html', { animation: $scope.animation || 'lift' });
                $rootScope.pushPage($scope.uuid, { animation: $scope.animation || 'lift' });
            };
        }]
    };
}]);