module.directive('fsrProfilePhoto', ['$timeout',function ($timeout) {
    return {
        restrict: 'E',
        replace: false,
        template: '<img ng-src="{{path}}" class="profile-photo"></span>',
        scope:{
            user:'='
        },
        link:function(scope,element,attrs){
            //var flagClass = 'flag-icon-fsr';
            var FACEBOOK_IMAGE_URL = 'https://graph.facebook.com/{id}/picture?type=square&height=100&width=100';

            var countryCodes = _countryCodes();
            var code = scope.user.country;

        	//does the user have a Facebook phote
            if (scope.user && scope.user.facebook_id) {
                //$(element).find('.flag').css('background-image', FACEBOOK_IMAGE_URL.replace('{id}', scope.user.facebook_id))
                scope.path = FACEBOOK_IMAGE_URL.replace('{id}', scope.user.facebook_id);
            	return;
            }


            var convertedCode = '';
            if(code){
                if(code.length === 3){
                    countryCodes.some(function(item){
                        if(item.abbr == code.toUpperCase()){
                            convertedCode = item;
                        }
                    });
                }

                else if(code.length === 2){
                    convertedCode = {code:code};
                }

                if(convertedCode){
                    //flagClass = 'flag-icon-' + convertedCode.code.toLocaleLowerCase();
                    scope.path = 'js/libs/flag-icon-css/flags/4x3/' + convertedCode.code.toLocaleLowerCase() + '.svg';
                }

            }

            //$(element).find('.flag').addClass(flagClass);

        	//---Lookup

            function _countryCodes() {
            	return [
					{ "code": "us", "abbr": "USA", "name": "United States" },
					{ "code": "ar", "abbr": "ARG", "name": "Argentina" },
					{ "code": "au", "abbr": "AUS", "name": "Australia" },
					{ "code": "at", "abbr": "AUT", "name": "Austria" },
					{ "code": "be", "abbr": "BEL", "name": "Belgium" },
					{ "code": "ca", "abbr": "CAN", "name": "Canada" },
					{ "code": "cl", "abbr": "CHI", "name": "Chile" },
					{ "code": "hr", "abbr": "CRO", "name": "Croatia" },
					{ "code": "cz", "abbr": "CZE", "name": "Czech Republic" },
					{ "code": "dk", "abbr": "DEN", "name": "Denmark" },
					{ "code": "fi", "abbr": "FIN", "name": "Finland" },
					{ "code": "fr", "abbr": "FRA", "name": "France" },
					{ "code": "de", "abbr": "GER", "name": "Germany" },
					{ "code": "gb", "abbr": "GBR", "name": "Great Britain" },
					{ "code": "hu", "abbr": "HUN", "name": "Hungary" },
					{ "code": "is", "abbr": "IS", "name": "Iceland" },
					{ "code": "ie", "abbr": "IRL", "name": "Ireland" },
					{ "code": "ie", "abbr": "IRE", "name": "Ireland" },
					{ "code": "it", "abbr": "ITA", "name": "Italy" },
					{ "code": "jp", "abbr": "JPN", "name": "Japan" },
					{ "code": "kr", "abbr": "KOR", "name": "Korea" },
					{ "code": "li", "abbr": "LIE", "name": "Liechtenstein" },
					{ "code": "lt", "abbr": "LTU", "name": "Lithuania" },
					{ "code": "lu", "abbr": "LUX", "name": "Luxembourg" },
					{ "code": "nl", "abbr": "NLD", "name": "Netherlands" },
					{ "code": "nz", "abbr": "NZE", "name": "New Zealand" },
					{ "code": "no", "abbr": "NOR", "name": "Norway" },
					{ "code": "pl", "abbr": "POL", "name": "Poland" },
					{ "code": "ru", "abbr": "RUS", "name": "Russia" },
					{ "code": "sk", "abbr": "SVK", "name": "Slovakia" },
					{ "code": "si", "abbr": "SVN", "name": "Slovenia" },
					{ "code": "si", "abbr": "SLO", "name": "Slovenia" },
					{ "code": "es", "abbr": "ESP", "name": "Spain" },
					{ "code": "se", "abbr": "SWE", "name": "Sweden" },
					{ "code": "ch", "abbr": "SUI", "name": "Switzerland" },
					{ "code": "tr", "abbr": "TUR", "name": "Turkey" }
            	];
            }
			/*
             function _countryCodes(){ return [
                    {two:"AX",three:"ALA"},
                    {two:"AL",three:"ALB"},
                    {two:"DZ",three:"DZA"},
                    {two:"AS",three:"ASM"},
                    {two:"AD",three:"AND"},
                    {two:"AO",three:"AGO"},
                    {two:"AI",three:"AIA"},
                    {two:"AQ",three:"ATA"},
                    {two:"AG",three:"ATG"},
                    {two:"AR",three:"ARG"},
                    {two:"AM",three:"ARM"},
                    {two:"AW",three:"ABW"},
                    {two:"AU",three:"AUS"},
                    {two:"AT",three:"AUT"},
                    {two:"AZ",three:"AZE"},
                    {two:"BS",three:"BHS"},
                    {two:"BH",three:"BHR"},
                    {two:"BD",three:"BGD"},
                    {two:"BB",three:"BRB"},
                    {two:"BY",three:"BLR"},
                    {two:"BE",three:"BEL"},
                    {two:"BZ",three:"BLZ"},
                    {two:"BJ",three:"BEN"},
                    {two:"BM",three:"BMU"},
                    {two:"BT",three:"BTN"},
                    {two:"BO",three:"BOL"},
                    {two:"BA",three:"BIH"},
                    {two:"BW",three:"BWA"},
                    {two:"BV",three:"BVT"},
                    {two:"BR",three:"BRA"},
                    {two:"VG",three:"VGB"},
                    {two:"IO",three:"IOT"},
                    {two:"BN",three:"BRN"},
                    {two:"BG",three:"BGR"},
                    {two:"BF",three:"BFA"},
                    {two:"BI",three:"BDI"},
                    {two:"KH",three:"KHM"},
                    {two:"CM",three:"CMR"},
                    {two:"CA",three:"CAN"},
                    {two:"CV",three:"CPV"},
                    {two:"KY",three:"CYM"},
                    {two:"CF",three:"CAF"},
                    {two:"TD",three:"TCD"},
                    {two:"CL",three:"CHL"},
                    {two:"CN",three:"CHN"},
                    {two:"HK",three:"HKG"},
                    {two:"MO",three:"MAC"},
                    {two:"CX",three:"CXR"},
                    {two:"CC",three:"CCK"},
                    {two:"CO",three:"COL"},
                    {two:"KM",three:"COM"},
                    {two:"CG",three:"COG"},
                    {two:"CD",three:"COD"},
                    {two:"CK",three:"COK"},
                    {two:"CR",three:"CRI"},
                    {two:"CI",three:"CIV"},
                    {two:"HR",three:"HRV"},
                    {two:"CU",three:"CUB"},
                    {two:"CY",three:"CYP"},
                    {two:"CZ",three:"CZE"},
                    {two:"DK",three:"DNK"},
                    {two:"DJ",three:"DJI"},
                    {two:"DM",three:"DMA"},
                    {two:"DO",three:"DOM"},
                    {two:"EC",three:"ECU"},
                    {two:"EG",three:"EGY"},
                    {two:"SV",three:"SLV"},
                    {two:"GQ",three:"GNQ"},
                    {two:"ER",three:"ERI"},
                    {two:"EE",three:"EST"},
                    {two:"ET",three:"ETH"},
                    {two:"FK",three:"FLK"},
                    {two:"FO",three:"FRO"},
                    {two:"FJ",three:"FJI"},
                    {two:"FI",three:"FIN"},
                    {two:"FR",three:"FRA"},
                    {two:"GF",three:"GUF"},
                    {two:"PF",three:"PYF"},
                    {two:"TF",three:"ATF"},
                    {two:"GA",three:"GAB"},
                    {two:"GM",three:"GMB"},
                    {two:"GE",three:"GEO"},
                    {two:"DE",three:"DEU"},
                    {two:"GH",three:"GHA"},
                    {two:"GI",three:"GIB"},
                    {two:"GR",three:"GRC"},
                    {two:"GL",three:"GRL"},
                    {two:"GD",three:"GRD"},
                    {two:"GP",three:"GLP"},
                    {two:"GU",three:"GUM"},
                    {two:"GT",three:"GTM"},
                    {two:"GG",three:"GGY"},
                    {two:"GN",three:"GIN"},
                    {two:"GW",three:"GNB"},
                    {two:"GY",three:"GUY"},
                    {two:"HT",three:"HTI"},
                    {two:"HM",three:"HMD"},
                    {two:"VA",three:"VAT"},
                    {two:"HN",three:"HND"},
                    {two:"HU",three:"HUN"},
                    {two:"IS",three:"ISL"},
                    {two:"IN",three:"IND"},
                    {two:"ID",three:"IDN"},
                    {two:"IR",three:"IRN"},
                    {two:"IQ",three:"IRQ"},
                    {two:"IE",three:"IRL"},
                    {two:"IM",three:"IMN"},
                    {two:"IL",three:"ISR"},
                    {two:"IT",three:"ITA"},
                    {two:"JM",three:"JAM"},
                    {two:"JP",three:"JPN"},
                    {two:"JE",three:"JEY"},
                    {two:"JO",three:"JOR"},
                    {two:"KZ",three:"KAZ"},
                    {two:"KE",three:"KEN"},
                    {two:"KI",three:"KIR"},
                    {two:"KP",three:"PRK"},
                    {two:"KR",three:"KOR"},
                    {two:"KW",three:"KWT"},
                    {two:"KG",three:"KGZ"},
                    {two:"LA",three:"LAO"},
                    {two:"LV",three:"LVA"},
                    {two:"LB",three:"LBN"},
                    {two:"LS",three:"LSO"},
                    {two:"LR",three:"LBR"},
                    {two:"LY",three:"LBY"},
                    {two:"LI",three:"LIE"},
                    {two:"LT",three:"LTU"},
                    {two:"LU",three:"LUX"},
                    {two:"MK",three:"MKD"},
                    {two:"MG",three:"MDG"},
                    {two:"MW",three:"MWI"},
                    {two:"MY",three:"MYS"},
                    {two:"MV",three:"MDV"},
                    {two:"ML",three:"MLI"},
                    {two:"MT",three:"MLT"},
                    {two:"MH",three:"MHL"},
                    {two:"MQ",three:"MTQ"},
                    {two:"MR",three:"MRT"},
                    {two:"MU",three:"MUS"},
                    {two:"YT",three:"MYT"},
                    {two:"MX",three:"MEX"},
                    {two:"FM",three:"FSM"},
                    {two:"MD",three:"MDA"},
                    {two:"MC",three:"MCO"},
                    {two:"MN",three:"MNG"},
                    {two:"ME",three:"MNE"},
                    {two:"MS",three:"MSR"},
                    {two:"MA",three:"MAR"},
                    {two:"MZ",three:"MOZ"},
                    {two:"MM",three:"MMR"},
                    {two:"NA",three:"NAM"},
                    {two:"NR",three:"NRU"},
                    {two:"NP",three:"NPL"},
                    {two:"NL",three:"NLD"},
                    {two:"AN",three:"ANT"},
                    {two:"NC",three:"NCL"},
                    {two:"NZ",three:"NZL"},
                    {two:"NI",three:"NIC"},
                    {two:"NE",three:"NER"},
                    {two:"NG",three:"NGA"},
                    {two:"NU",three:"NIU"},
                    {two:"NF",three:"NFK"},
                    {two:"MP",three:"MNP"},
                    {two:"NO",three:"NOR"},
                    {two:"OM",three:"OMN"},
                    {two:"PK",three:"PAK"},
                    {two:"PW",three:"PLW"},
                    {two:"PS",three:"PSE"},
                    {two:"PA",three:"PAN"},
                    {two:"PG",three:"PNG"},
                    {two:"PY",three:"PRY"},
                    {two:"PE",three:"PER"},
                    {two:"PH",three:"PHL"},
                    {two:"PN",three:"PCN"},
                    {two:"PL",three:"POL"},
                    {two:"PT",three:"PRT"},
                    {two:"PR",three:"PRI"},
                    {two:"QA",three:"QAT"},
                    {two:"RE",three:"REU"},
                    {two:"RO",three:"ROU"},
                    {two:"RU",three:"RUS"},
                    {two:"RW",three:"RWA"},
                    {two:"BL",three:"BLM"},
                    {two:"SH",three:"SHN"},
                    {two:"KN",three:"KNA"},
                    {two:"LC",three:"LCA"},
                    {two:"MF",three:"MAF"},
                    {two:"PM",three:"SPM"},
                    {two:"VC",three:"VCT"},
                    {two:"WS",three:"WSM"},
                    {two:"SM",three:"SMR"},
                    {two:"ST",three:"STP"},
                    {two:"SA",three:"SAU"},
                    {two:"SN",three:"SEN"},
                    {two:"RS",three:"SRB"},
                    {two:"SC",three:"SYC"},
                    {two:"SL",three:"SLE"},
                    {two:"SG",three:"SGP"},
                    {two:"SK",three:"SVK"},
                    {two:"SI",three:"SVN"},
                    {two:"SB",three:"SLB"},
                    {two:"SO",three:"SOM"},
                    {two:"ZA",three:"ZAF"},
                    {two:"GS",three:"SGS"},
                    {two:"SS",three:"SSD"},
                    {two:"ES",three:"ESP"},
                    {two:"LK",three:"LKA"},
                    {two:"SD",three:"SDN"},
                    {two:"SR",three:"SUR"},
                    {two:"SJ",three:"SJM"},
                    {two:"SZ",three:"SWZ"},
                    {two:"SE",three:"SWE"},
                    {two:"CH",three:"CHE"},
                    {two:"SY",three:"SYR"},
                    {two:"TW",three:"TWN"},
                    {two:"TJ",three:"TJK"},
                    {two:"TZ",three:"TZA"},
                    {two:"TH",three:"THA"},
                    {two:"TL",three:"TLS"},
                    {two:"TG",three:"TGO"},
                    {two:"TK",three:"TKL"},
                    {two:"TO",three:"TON"},
                    {two:"TT",three:"TTO"},
                    {two:"TN",three:"TUN"},
                    {two:"TR",three:"TUR"},
                    {two:"TM",three:"TKM"},
                    {two:"TC",three:"TCA"},
                    {two:"TV",three:"TUV"},
                    {two:"UG",three:"UGA"},
                    {two:"UA",three:"UKR"},
                    {two:"AE",three:"ARE"},
                    {two:"GB",three:"GBR"},
                    {two:"US",three:"USA"},
                    {two:"UM",three:"UMI"},
                    {two:"UY",three:"URY"},
                    {two:"UZ",three:"UZB"},
                    {two:"VU",three:"VUT"},
                    {two:"VE",three:"VEN"},
                    {two:"VN",three:"VNM"},
                    {two:"VI",three:"VIR"},
                    {two:"WF",three:"WLF"},
                    {two:"EH",three:"ESH"},
                    {two:"YE",three:"YEM"},
                    {two:"ZM",three:"ZMB"},
                    {two:"ZW",three:"ZWE"}

                ];}
			*/
        }
    };
}]);