module.directive('fsrRanking', function () {
    return {
        restrict: 'E',
        replace: true,
        template: '<span class="ranking"></span>',
        scope: {
            ranking: '=',
            hideTrophies: '=?'
        },
        link: function (scope, element, attrs) {
            scope.$watch(
		        function (scope) {
		            return scope.ranking;
		        },
		        function (newValue, oldValue) {
		            if (newValue && newValue != oldValue) {
		                scope.update(newValue);
		            }
		        });
            scope.update = function (r, hideTrophies) {
                if (r) {
                    var ranking = parseInt(r);
                    var $element = $(element);
                    $element.removeAttr("class");
                    $element.text('');
                    if (ranking) {
                        if (ranking === 1 && !hideTrophies) {
                            $element.addClass('ranking fa fa-trophy gold');
                        } else if (ranking === 2 && !hideTrophies) {
                            $(element).addClass('ranking fa fa-trophy silver');
                        } else if (ranking === 3 && !hideTrophies) {
                            $element.addClass('ranking fa fa-trophy bronze');
                            // DNF
                        } else if (ranking === 999) {
                            $element.addClass('ranking');
                            $element.text('-');
                        } else {
                            $element.addClass('ranking');
                            $element.text(ranking);
                        }
                    }
                        // DNF / Non-number
                    else {
                        $element.addClass('ranking');
                        $element.text('-');
                    }
                }
            };
            scope.update(scope.ranking, scope.hideTrophies);
        }
    };
});