module.directive('fsrUserProfileItem', ['$timeout', function ($timeout) {
    return {
        restrict: 'E',
        replace: false,
        templateUrl: './templates/directives/fsr-userProfileItem.html',
        scope: {
        	user: '=',
        	showpct: '=',
        	minimal: '=',
			score: '='
        },
        transclude: true,
        controller: ['$rootScope', '$scope', '$translate', 'socialService', 'navService', function ($rootScope, $scope, $translate, socialService, navService) {
            $scope.view = function (user) {
                var currentPage = $rootScope.getNavigator().getCurrentPage();
                if (currentPage.options && currentPage.options.user && currentPage.options.user.user_id === user.user_id) {
                    // don't do anything, the current user's profile is already at the top of the display stack
                }
                else
                {
                    $rootScope.pushPage('partials/social/profile.html', { user: user });
                    navService.push({ title: $translate.instant('Profile'), controlContext: false });
                }
        	};

        	$scope.follow = function (user) {
        		if (user.social && !user.social.loading) {
        			user.social.loading = 1;
        			socialService.Follow.follow({ id: user.user_id }, function success(data) {
        				user.social.loading = 0;
        				user.social.following = true;

        			}, function error(err) {
        				user.social.loading = 0;
        			});
        		}
        		return false;
        	};

        	$scope.unfollow = function (user) {
        		if (user.social && !user.social.loading) {
        			user.social.loading = 1;
        			socialService.Follow.unfollow({ id: user.user_id }, function success(data) {
        				user.social.loading = 0;
        				user.social.following = false;

        			}, function error(err) {
        				user.social.loading = 0;
        			});
        		}
        		return false;
        	};
        }],
        link: function (scope, element, attrs) {

        }
    };
}]);