filters.filter('fsrTiming',['$filter', function ($filter) {
    return function (input, d) {
        var decimals = d || 2; // round to this many
        if (!input || typeof input !== 'string') {
            return input;
        }
        else
        {
            var items = input.split(":");
            if (items.length && items.length > 0) {
                var output = [];
                var startPushing = false;
                for (var i = 0; i < items.length; i++) {
                    if (items[i] != "00") {
                        startPushing = true;
                    }
                    if (startPushing) {
                        output.push(items[i]);
                    }
                }
                if (output.length > 1) {
                    if (!isNaN(parseInt(output[0])) && isFinite(output[0])) {
                        output[0] = parseInt(output[0]).toString();
                    }
                    var seconds = $filter('number')(parseFloat(output[output.length - 1]), decimals);
                    output[output.length - 1] = seconds < 10 ? '0' + seconds : seconds;
                    return output.join(":");
                }
                else if (output.length == 1) {
                    if (!isNaN(parseFloat(output[0])) && isFinite(output[0])) {
                        output[0] = parseFloat(output[0]).toString();
                    }
                    return $filter('number')(output[0], decimals);
                }
                else {
                    return "";
                }
            }
            else {
                return "";
            }
        }
    };
}]);
