﻿// This is my preferred Cordova detection method, as it doesn't require updating.
if (document.URL.indexOf('http://') === -1 && document.URL.indexOf('https://') === -1) {
    // Running in Cordova/PhoneGap
    document.addEventListener("deviceready", onDeviceReady, false);
    document.addEventListener("resume", onResume, false);
} else {
    // Running in browser
    document.addEventListener("DOMContentLoaded", function (event) {
        initAngularApp();
    });
}

function onResume() {
    var pushNotification = window.plugins.pushNotification;
    //reset badges on app resume
    pushNotification.setApplicationIconBadgeNumber(0);
}

function onDeviceReady() {
    initDeviceCss();
    initStatusBar();
    //initPushwoosh();
    initAngularApp();
}

function initAngularApp() {
    angular.bootstrap(document.body, ['fsrTopTen'], { strictDi: true });
}

function initDeviceCss() {
    if (deviceIsIOS) {
        document.body.className = document.body.className + " fullscreen ios";
    }
    else if (deviceIsAndroid) {
        document.body.className = document.body.className + " fullscreen android";
    }
}

function initStatusBar() {
    // StatusBar for iOS
    if (StatusBar) {
        StatusBar.overlaysWebView(true);
        StatusBar.styleLightContent();
    }
}

function initPushwoosh() {
    var pushNotification = window.plugins.pushNotification;

    //set push notification callback before we initialize the plugin
    document.addEventListener('push-notification', function (event) {
        //get the notification payload
        var notification = event.notification;
        var message = notification.aps.alert;
        var title = notification.title || 'Fantasy Ski Racer';

        
        if (message) {
            //display alert to the user
            navigator.notification.alert(
                message,  			// message
                function () { },	// callback
                title,				// title
                'OK'				// buttonName
            );
        }
        
        //clear the app badge
        pushNotification.setApplicationIconBadgeNumber(0);
    });

    //initialize the plugin
    pushNotification.onDeviceReady({ projectid: "535867155267", appid: "A994F-C82EB", pw_appid: "A994F-C82EB" });

    //register for pushes
    pushNotification.registerDevice(
        function (status) {
            var deviceToken = status['deviceToken'];
            console.warn('registerDevice: ' + deviceToken);
        },
        function (status) {
            console.warn('failed to register : ' + JSON.stringify(status));
            alert(JSON.stringify(['failed to register', status]));
        }
    );

    //reset badges on app start
    pushNotification.setApplicationIconBadgeNumber(0);
}