﻿'use strict';
var interceptors = angular.module('fsrTopTenInterceptorServices', ['ngResource', 'angularLocalStorage', 'fsrTopTenServices']);

interceptors.factory('AuthInterceptorService', ['$rootScope', '$q', '$location', '$storage', 'appSettings', 'sportContextService', function ($rootScope, $q, $location, $storage, appSettings, sportContextService) {

	var authInterceptorServiceFactory = {};

	var _request = function (config) {

		config.headers = config.headers || {};
		
		var authData = $storage.get('authorizationData');
		
		if (authData && authData.isAuth && config.url && config.url.indexOf(appSettings.serviceBase) >= 0) {
		    config.headers.Authorization = 'Bearer ' + authData.token;
		    config.headers.Sport = sportContextService.getContext();
		}

        if (config.url && config.url.indexOf('.html') >= 0) {
		    if (config.url.indexOf('?') >= 0) {
		        config.url = config.url + '&v=1.6.9';
		    }
		    else {
		        config.url = config.url + '?v=1.6.9';
		    }
		}
        
		return config;
	}

	var _responseError = function (rejection) {
		if (rejection.status === 401) {
			$storage.remove('authorizationData');
			$location.path('/login');
		}
		return $q.reject(rejection);
	}

	authInterceptorServiceFactory.request = _request;
	authInterceptorServiceFactory.responseError = _responseError;

	return authInterceptorServiceFactory;
}]);