﻿// controls the global toolbar

services.service('navService', ['$rootScope', '$localStorage', function ($rootScope, $localStorage) {

    var vm = this;

    // { title: $translate.instant('Leagues'), controlContext: true }
    vm.initializeStack = function (config) {
        if (config) {
            $localStorage.nav = [config];
        } else {
            $localStorage.nav = [];
        }
    };

    vm.isInitialized = function() {
        return $localStorage.nav;
    };

    // Push a navigation object onto the nav object array
    vm.push = function (config) {
        // If we're embedded and the last page isn't already at the end of the nav array
        if ($localStorage.nav[$localStorage.nav.length - 1].title !== config.title) {
            $localStorage.nav.push(config);
        }
    };

    vm.getTitle = function () {
        return $localStorage.nav && $localStorage.nav.length > 0 ? $localStorage.nav[$localStorage.nav.length - 1].title : '';
    };

    vm.getBase = function() {
        return $localStorage.nav && $localStorage.nav.length > 0 ? $localStorage.nav[0] : undefined;
    }

    vm.pop = function() {
        if ($localStorage.nav.length > 1) {
            $localStorage.nav.pop();
        }
    }

    vm.isNested = function () {
        //return $localStorage.nav.isNested;
        return $rootScope.getNavigator() ? $rootScope.getNavigator().getPages().length > 1 : false;
    };
  
    vm.getContextControl = function () {
        if ($localStorage.nav.length > 0) {
            return $localStorage.nav[$localStorage.nav.length - 1].controlContext;
        }
    }

}]);