services.factory('TourService', ['$rootScope', '$translate', 'appSettings', 'dataService', function ($rootScope, $translate, appSettings, dataService) {
    var singleton = null;
    var tourRunning = false;

    if (this.singleton == null) {
        //----Private----
        var
            _start = function (id) {
                if (tourRunning) {
                    //console.log("tour already running");
                }
                else {
                    tourRunning = true;
                    dataService.Tour.get({id: id}, function (data) {
                        try {
                            if (data.tourOptions) {
                                var options = JSON.parse(data.tourOptions);

                                options.name = id;

                                if (appSettings.DEBUG == 'TRUE') {
                                    options.storage = false;
                                }
                                else {
                                    options.storage = localStorage;
                                }

                                options.onEnd = function (tour) {
                                    tourRunning = false;
                                };

                                options.steps.forEach(function (step) {
                                    step.title = $translate.instant(step.title);
                                    step.content = $translate.instant(step.content);
                                });

                                var tour = new Tour(options);
                                tour.init();
                                tour.start();

                                tourRunning = !tour.ended();
                            }
                            else {
                                tourRunning = false;
                            }
                        } catch(e) {
                            tourRunning = false;
                        }
                    });
                }
            };

        //----------------

        //----Public----

        this.singleton = {
            Running: tourRunning,
            Start: _start
        };
    }
    return this.singleton;
    //-------------
}]);
