﻿var module = angular.module('nxValidators', []);

module.directive('nxEqual', function () {
	return {
		require: 'ngModel',
		link: function (scope, elem, attrs, model) {
			if (!attrs.nxEqual) {
				console.error('nxEqual expects a model as an argument!');
				return;
			}
			scope.$watch(attrs.nxEqual, function (value) {
				// Only compare values if the second ctrl has a value.
				if (model.$viewValue !== undefined && model.$viewValue !== '') {
					model.$setValidity('nxEqual', value === model.$viewValue);
				}
			});
			model.$parsers.push(function (value) {
				// Mute the nxEqual error if the second ctrl is empty.
				if (value === undefined || value === '') {
					model.$setValidity('nxEqual', true);
					return value;
				}
				var isValid = value === scope.$eval(attrs.nxEqual);
				model.$setValidity('nxEqual', isValid);
				return isValid ? value : undefined;
			});
		}
	};
});

